CREATE DATABASE IF NOT EXISTS daj;

USE daj;

CREATE TABLE IF NOT EXISTS daj_files    (
        id              int(11)         not null        auto_increment,
        filename        varchar(255)    not null,
        genre           varchar(30)     default "",
        artist          varchar(60)     default "",
        track           varchar(60)     default "",
        album           varchar(60)     default "",
        songnb          int(11)         default 0,
        min             int(11)         default 0,
        sec             int(11)         default 0,
        hits            int(11)         default 0,
        albumdate       timestamp(14),
        bitrate         int(11)         default 0,
        frequency       int(11)         default 0,
        PRIMARY KEY     (id, filename),
	UNIQUE id (id),
	UNIQUE filename (filename)
	);       	

CREATE TABLE IF NOT EXISTS daj_playlist (
        id              INT AUTO_INCREMENT PRIMARY KEY,
	song_id         INT,
	playlist_id	INT
	);

GRANT ALL PRIVILEGES ON *.* TO daj_user@localhost IDENTIFIED BY 'secret_password' WITH GRANT OPTION;