#!/usr/bin/perl -w

#    Digital Audio Jukebox Perl/Tk Client
#    Copyright (C) 2003  Ben Willcox (http://www.willcoxonline.com)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


use Tk;					# Tk GUI library
use IO::Socket;
use IO::Select;
#use strict;
my $select=IO::Select->new();

my $socket_input="";
my $setmode="";			
#my @track_ids;
my @playlist_vars;
#my $playlist_length;
my $Form1 = MainWindow->new;
my $active_playlist=0;			# Currently selected channel/playlist
#my $element;
#my $os="unix";
my $os="windows";

#my $current_channel;
# 
my $no_channels=0;

# <Name><current song length><current song position><slider position><current song frames><channel volume>
my @channels;


my @buttons;

my $remote_server='192.168.1.13';
my $remote_port='7769';
my $logging='1'; 			# Set to log network messages to the console

my $server=IO::Socket::INET->new(Proto=>"tcp", PeerAddr=>$remote_server, PeerPort=>$remote_port); 
if (!$server)
{
	$Form1->messageBox(	-title=>'Cannot connect',
				-message=>"Cannot connect to server $remote_server!",
				-type=>'OK');
#	exit;
};
#$server->autoflush(1);

$select->add($server);	# add the server socket handle to Select


#-------------------------------------------------------
# Create main form and widgets
#-------------------------------------------------------
$Form1->title("Digital Audio Jukebox");
$Form1->geometry("663x402+8+8");

my $Label1 = $Form1->Label(-text => "Artist:");
$Label1->place(-width => 96, 
               -height => 16, 
               -x => 24, 
               -y => 24);

my $Label2 = $Form1->Label(-text => "Album:");
$Label2->place(-width => 72, 
               -height => 16, 
               -x => 168, 
               -y => 24);

my $Label3 = $Form1->Label(-text => "Track:");
$Label3->place(-width => 64, 
               -height => 16, 
               -x => 168, 
               -y => 112);

my $Label4 = $Form1->Label(-text => "Playlist:");
$Label4->place(-width => 72, 
               -height => 16, 
               -x => 168, 
               -y => 248);


my $btn_play = $Form1->Button(-text => "Play");
$btn_play->bind('<Button-1>',sub{send_data("playlist:$active_playlist:play");});
$btn_play->place(-width => 40, 
                 -height => 24, 
                 -x => 16, 
                 -y => 350);

my $btn_pause = $Form1->Button(-text => "Pause");
$btn_pause->bind('<Button-1>',sub{send_data("playlist:$active_playlist:pause");});
$btn_pause->place(-width => 40, 
                  -height => 24, 
                  -x => 64, 
                  -y => 350);

my $btn_stop = $Form1->Button(-text => "Stop");
$btn_stop->bind('<Button-1>',sub{send_data("playlist:$active_playlist:stop");});
$btn_stop->place(-width => 40, 
                 -height => 24, 
                 -x => 112, 
                 -y => 350);

my $lst_artist = $Form1->Scrolled('Listbox', -scrollbars=>'oe', -exportselection=>'false');
$lst_artist->bind('<Button-1>',\&update_album_list);
$lst_artist->place(-width => 136, 
                   -height => 176, 
                   -x => 16, 
                   -y => 40);

my $lst_album = $Form1->Scrolled('Listbox', -scrollbars=>'oe', -exportselection=>'false');
$lst_album->bind('<Button-1>',\&update_track_list);
$lst_album->bind('<Double-Button-1>',\&select_all_tracks);
$lst_album->place(-width => 360, 
                  -height => 64, 
                  -x => 160, 
                  -y => 40);

my $lst_track = $Form1->Scrolled('Listbox', -scrollbars=>'oe', -exportselection=>'false',-selectmode=>'extended');
$lst_track->bind('<Double-Button-1>',\&add_playlist);
$lst_track->place(-width => 360, 
                  -height => 88, 
                  -x => 160, 
                  -y => 128);


#my $btn_dbsync = $Form1->Button(-text => "Sync Database");
#$btn_dbsync->bind('<Button-1>',\&dbsync);
#$btn_dbsync->place(-width => 88, 
 #                       -height => 48, 
 #                       -x => 544, 
 #                       -y => 44);


my $btn_addplaylist = $Form1->Button(-text => "Add To Playlist");
$btn_addplaylist->bind('<Button-1>',\&add_playlist);
$btn_addplaylist->place(-width => 88, 
                        -height => 48, 
                        -x => 544, 
                        -y => 144);

my $btn_delete = $Form1->Button(-text => "Delete");
$btn_delete->bind('<Button-1>',\&delete_playlist);
$btn_delete->place(-width => 64, 
                   -height => 24, 
                   -x => 488, 
                   -y => 294);

my $btn_skip = $Form1->Button(-text => "Skip Track");
$btn_skip->bind('<Button-1>',sub{send_data("playlist:$active_playlist:skip")});
$btn_skip->place(-width => 64, 
                 -height => 24, 
                 -x => 488, 
                 -y => 326);

my $btn_randomize = $Form1->Button(-text => "Randomize");
$btn_randomize->place(-width => 64, 
                      -height => 24, 
                      -x => 488, 
                      -y => 358);


my @lst_playlist;


$current_channel=0;
$menubar = $Form1->Menu(-tearoff => 0);
my $stuff_menu = $menubar->cascade(-label => "~Current Playlist", -tearoff =>0);
my $copyto_menu = $stuff_menu->cascade(-label => "~Copy to...", -tearoff =>0);
my $copyfrom_menu = $stuff_menu->cascade(-label => "~Copy from...", -tearoff =>0);
my $moveto_menu = $stuff_menu->cascade(-label => "~Move to...", -tearoff =>0);
my $movefrom_menu = $stuff_menu->cascade(-label => "~Move from...", -tearoff =>0);
	
my $tools_menu = $menubar->cascade(-label => "~Tools", -tearoff=>0);
my $dbsync_menu = $tools_menu->command(-label => "~Sync Database", -command => \&dbsync);

$Form1->configure(-menu => $menubar);
# Send initial server commands:
send_data('get:channels');
send_data('get:artists');
$scale_volume = $Form1->Scale(-from => 100,
		-to=>0,
		-label=>'Volume',
		-width=>10,
		-tickinterval=>50,
		-sliderlength=>15,
		-orient=>'vertical');

$channel_frame = $Form1->Frame (); 	# Create frame to hold channel selector buttons
$channel_frame->place(	-width=>620,
			-height=>50,
			-x=>16,
			-y=>225);


	


if ($os eq 'windows') {$Form1->repeat(50, \&read_socket);};  
MainLoop;


############################ SUBS ############################
#-------------------------------------------------------------
sub create_controls # Create controls for each playlist (Position slider, channel select button, playlist listbox)
{
	$no_channels--;
	foreach $count (0..$no_channels)
	{
		my $current_channel=$count;
		$scale_position[$count] = $Form1->Scale(-from => 0,
				-to=> 1000,
        	         	-label=>'Time',
			 	-width=>10,
				-variable=>\$channels[$count][3],
				-sliderlength=>15,
				-orient=>'horizontal');
		$ch_btn[$count] = $channel_frame->Button(-text => "$count");
		$ch_btn[$count]->pack(-side=>'left',-anchor=>'nw'); 

		$ch_btn[$count]->bind('<ButtonRelease-1>',sub{hide_controls($active_playlist);show_controls($current_channel)});
		
		$lst_playlist[$count] = $Form1->Scrolled('Listbox', -scrollbars=>'oe', -exportselection=>'false',-selectmode=>'extended');
		$ch_btn[$current_channel]->configure(-text=>$channels[$current_channel][0]);
		
		# Populate menus		
		$lst_playlist[$count]->bind("<Button-3>" => sub {$menubar->Popup(-popover => "cursor", -popanchor => 'nw') });
		$copyto_menu->command(-label => "$channels[$current_channel][0]",-command => sub{send_data("PLAYLIST:$current_channel:COPY:$active_playlist")});
		$copyfrom_menu->command(-label => "$channels[$current_channel][0]",-command => sub{send_data("PLAYLIST:$active_playlist:COPY:$current_channel")});
		$moveto_menu->command(-label => "$channels[$current_channel][0]",-command => sub{send_data("PLAYLIST:$current_channel:MOVE:$active_playlist")});
		$movefrom_menu->command(-label => "$channels[$current_channel][0]",-command => sub{send_data("PLAYLIST:$active_playlist:MOVE:$current_channel")});
		
		send_data("get:volume:$current_channel");
		send_data("get:playlist:$current_channel");
	};
show_controls(0);
};

#-------------------------------------------------------------
sub show_controls # <playlist number>
{
	my $playlist_no=$_[0];
	$ch_btn[$playlist_no]->configure(-relief => 'sunken');

	$lst_playlist[$playlist_no]->place(-width => 312, 
                 -height => 88, 
                 -x => 160, 
                 -y => 294);

	$scale_volume->place(-width => 100, 
               -height => 100, 
               -x => 560, 
               -y => 290);

	$scale_volume->configure(-command=>sub{if ($channels[$playlist_no][5]) {send_data("PLAYLIST:$playlist_no:VOLUME:$channels[$playlist_no][5]")}},
				 -variable=>\$channels[$playlist_no][5]);
	$scale_position[$playlist_no]->bind('<ButtonRelease-1>',\&pos_seek);
	$scale_position[$playlist_no]->place(-width => 140, 
               -height => 70, 
               -x => 15, 
               -y => 280);
	$active_playlist=$playlist_no;
};

#-------------------------------------------------------------
sub dbsync
{
	send_data('DBSYNC');	
}
#-------------------------------------------------------------
sub hide_controls # <playlist numnber>
{
	my $playlist_no=$_[0];
	$lst_playlist[$playlist_no]->placeForget();
#	$scale_volume[$playlist_no]->placeForget();
	$scale_position[$playlist_no]->placeForget();
	$ch_btn[$playlist_no]->configure(-relief => 'raised');
};

#-------------------------------------------------------------
sub read_socket
{
	while (@ready = $select->can_read(.005)) 
	{
		foreach $fh (@ready)
 		{
			if (sysread ($fh,$buf,1) eq 0)
			{
				exit;
			};
			if ($buf ne "\n")
			{
				if ($buf ne "\r"){$socket_input=join "",$socket_input,$buf};
			}
			else
			{
				print "\c[\[33mRECEIVED: $socket_input\c[\[37m\n";
				receive_data("$socket_input");
				$socket_input="";
			};
		};
	};
};

#-------------------------------------------------------------
sub send_data
{
	if ($logging) {print "\c[\[32mSEND: $_[0]\c[\[37m\n"};
	$Form1->fileevent($server,"readable",'');
	print $server "$_[0]\n";
	if ($os ne 'windows') {$Form1->fileevent($server,"readable",\&read_socket);};
};

#-------------------------------------------------------------
sub receive_data
{
	my @rec_data=split(/:/,$_[0]);
	if ($rec_data[0] eq "MSG_ARTISTS")
	{
		$setmode='artists';
		$lst_artist->delete(0,'end');
	}
	elsif ($rec_data[0] eq "MSG_CHANNELS")
	{
		$setmode='channels';
		$no_channels=0;
	}
	elsif ($rec_data[0] eq "MSG_VOLUME")
	{
		$channels[$rec_data[1]][5]=$rec_data[2];	
	}
	elsif ($rec_data[0] eq "MSG_ALBUMS")
	{
		$setmode='albums';
		$lst_album->delete(0,'end');
	}
	elsif ($rec_data[0] eq "MSG_TRACKS")
	{
		$setmode='tracks';
		$lst_track->delete(0,'end');
		@track_ids=();
	}
	elsif ($rec_data[0] eq "MSG_PLAYLIST")
	{
		$current_channel=$rec_data[1];
		$setmode='playlistadd';
	}
	elsif ($rec_data[0] eq "MSG_DELETE_PLAYLIST")
	{
		my $to_delete;
			$current_channel=$rec_data[1];
			for $count (0 .. (@{$playlist_vars[$current_channel]}-1))
			{
				if($playlist_vars[$current_channel][$count] eq $rec_data[2])
				{
					$to_delete = $count
				};
			};
		$lst_playlist[$current_channel]->delete($to_delete);
		splice (@{$playlist_vars[$current_channel]}, $to_delete,1);
	}
	elsif ($rec_data[0] eq "MSG_ADD_PLAYLIST")
	{
		$current_channel=$rec_data[1];
		$setmode='playlistadd';
	}
	elsif ($rec_data[0] eq "MSG_POS")
	{
		$current_channel=$rec_data[1];
		$channels[$current_channel][1]=$rec_data[2]+$rec_data[3];	# Set current song length
		$channels[$current_channel][2]=$rec_data[2];			# Set current song position
		$channels[$current_channel][4]=$rec_data[4];			# Set current song frames
		$scale_position[$current_channel]->configure(	-to=>$rec_data[2]+$rec_data[3],
								-tickinterval=>$rec_data[2]+$rec_data[3]);
		$scale_position[$current_channel]->set($rec_data[2]);
	}
	elsif ($_[0] eq 'MSG_OK')
	{
		if ($setmode eq 'albums')
		{
			$lst_album->selectionSet(0,0);
			update_track_list();
		};
		
		if ($setmode eq 'channels')
		{	
			create_controls();
			$setmode='';
		};
	}
	elsif ($setmode eq 'playlistadd')
	{
		my @tmp=split (/:/,$_[0]);
		$lst_playlist[$current_channel]->insert('end',"$tmp[1], $tmp[2]");
		$playlist_vars[$current_channel][($lst_playlist[$current_channel]->size)-1]=$tmp[3];
	}	
	elsif ($setmode eq 'channels')
	{
		my @tmp=split (/:/,$_[0]);
		$channels[$no_channels][0]=$tmp[1];	
		$no_channels++;
	
	}
	elsif ($setmode eq 'artists')
	{
		$lst_artist->insert('end',$_[0]);
	}
	elsif ($setmode eq 'albums')
	{
		$lst_album->insert('end',$_[0]);
	}
	elsif ($setmode eq 'tracks')
	{
		my @tmp=split (/:/,$_[0]);	
		push @track_ids, $tmp[0];
		$lst_track->insert('end',$tmp[1]);
	};
};

#-------------------------------------------------------------
sub update_track_list
{
	send_data("get:tracks:".$lst_artist->get($lst_artist->curselection()).":".$lst_album->get($lst_album->curselection()));
};

#-------------------------------------------------------------
sub update_album_list
{
	send_data("get:albums:".$lst_artist->get($lst_artist->curselection()));
};

#-------------------------------------------------------------
sub add_playlist
{
	my @selected=$lst_track->curselection();
	foreach (@selected)
	{
		send_data("playlist:$active_playlist:add:".$track_ids[$_]);
		$lst_track->selectionClear($_);
	};
};

#-------------------------------------------------------------
sub pos_seek
{
	{
		if ($channels[$active_playlist][1]) {$frames_per_second=int($channels[$active_playlist][4]/$channels[$active_playlist][1])};
		if ($frames_per_second){send_data("PLAYLIST:$active_playlist:JUMP:".$channels[$active_playlist][3]*$frames_per_second)};
	};
};

#-------------------------------------------------------------
sub select_all_tracks
{
	$lst_track->selectionSet(0,'end');
};

#-------------------------------------------------------------
sub delete_playlist
{
	my @selected=$lst_playlist[$active_playlist]->curselection();
	foreach (@selected)
	
	{
		send_data("playlist:$active_playlist:delete:".$playlist_vars[$active_playlist][$_]);
	};
};
