# Configures front/rear outputs on a Soundblaster Live! 5.1 to use separate dsp devices,
# and enables/disables the SPDIF output and 12db output boost (for headphones).
# http://www.willcoxonline.com

DSPMGR="/usr/local/bin/emu-dspmgr" 
EMUCONFIG="/usr/local/bin/emu-config"

# First card
MIXER="/dev/mixer"
$EMUCONFIG -M $MIXER -d # Activate SPDIF digital output
$EMUCONFIG -M $MIXER -B on # Turn on the 12db boost on front analogue output (for headphones)
DSP="/dev/dsp"
$DSPMGR -D $DSP -M $MIXER -v"Pcm L:Front L" -mpcm_l
$DSPMGR -D $DSP -M $MIXER -v"Pcm R:Front R" -mpcm_r
DSP="/dev/dsp1"
$DSPMGR -D $DSP -M $MIXER -v"Pcm1 L:Rear L" -mpcm2_l
$DSPMGR -D $DSP -M $MIXER -v"Pcm1 R:Rear R" -mpcm2_r

# Second card
MIXER="/dev/mixer1"
$EMUCONFIG -M $MIXER -a # Activate analogue output
$EMUCONFIG -M $MIXER -B off # Turn off the 12db boost on front analogue output
DSP="/dev/dsp2"
$DSPMGR -D $DSP -M $MIXER -v"Pcm L:Front L" -mpcm_l
$DSPMGR -D $DSP -M $MIXER -v"Pcm R:Front R" -mpcm_r
DSP="/dev/dsp3"
$DSPMGR -D $DSP -M $MIXER -v"Pcm1 L:Rear L" -mpcm2_l
$DSPMGR -D $DSP -M $MIXER -v"Pcm1 R:Rear R" -mpcm2_r

# Third card
MIXER="/dev/mixer2"
$EMUCONFIG -M $MIXER -a # Use analogue output
$EMUCONFIG -M $MIXER -B off # Turn off the 12db boost on front analogue output
DSP="/dev/dsp4"
$DSPMGR -D $DSP -M $MIXER -v"Pcm L:Front L" -mpcm_l
$DSPMGR -D $DSP -M $MIXER -v"Pcm R:Front R" -mpcm_r
DSP="/dev/dsp5"
$DSPMGR -D $DSP -M $MIXER -v"Pcm1 L:Rear L" -mpcm2_l
$DSPMGR -D $DSP -M $MIXER -v"Pcm1 R:Rear R" -mpcm2_r


